/* global.h - some global variables and stuff defined here for Fake86. */

#include <stdlib.h>
#include <SDL/SDL.h>
#include "stdint.h"

//#define CONSOLE
//#define vidrec
#define USE_ASM
#ifdef _WIN32
    //#define REAL_LPT_IO
#endif
#define DATAPATH "/usr/share/fake86/"
#define CPU_TYPE 80186
#if defined(_WIN32)
    #define NETWORKING_ENABLED
#endif

#define StepIP(x) ip+=x
#define getmem8(x,y) read86(segbase(x)+y)
//#define getmem16(x,y) (read86(segbase(x)+y) | ((uint16_t)read86(segbase(x)+y+1)<<8))
#define getmem16(x,y) readw86(segbase(x)+y)
#define putmem8(x,y,z) write86(segbase(x)+y, z)
//#define putmem16(x,y,z) write86(segbase(x)+y, ((z)&0xFF)); write86(segbase(x)+y+1, (((z)>>8)&0xFF))
#define putmem16(x,y,z) writew86(segbase(x)+y, z)
//#define signext(value) ((((uint16_t)value&0x80)*0x1FE)|(uint16_t)value)
#define signext(value) ((value) & 0x80) ? ((value) | 0xFF00) : (value)
//#define signext32(value) ((((uint32_t)value&0x8000)*0x1FFFE)|(uint32_t)value)
#define signext32(value) ((value) & 0x8000) ? ((value) | 0xFFFF0000) : (value)
#define getreg16(regid) regs.wordregs[regid]
#define getreg8(regid) regs.byteregs[byteregtable[regid]]
#define putreg16(regid, writeval) regs.wordregs[regid] = writeval
#define putreg8(regid, writeval) regs.byteregs[byteregtable[regid]] = writeval
#define getsegreg(regid) segregs[regid]
#define putsegreg(regid, writeval) segregs[regid] = writeval
#define segbase(x) ((uint32_t)x<<4)

#define makeflagsword() (2 | (uint16_t)cf | ((uint16_t)pf << 2) | ((uint16_t)af << 4) | ((uint16_t)zf << 6) \
        | ((uint16_t)sf << 7) | ((uint16_t)tf << 8) | ((uint16_t)ifl << 9) | ((uint16_t)df << 10) | ((uint16_t)of << 11))

#define decodeflagsword(x) {\
        temp16 = x;\
        cf = temp16 & 1;\
        pf = (temp16 >> 2) & 1;\
        af = (temp16 >> 4) & 1;\
        zf = (temp16 >> 6) & 1;\
        sf = (temp16 >> 7) & 1;\
        tf = (temp16 >> 8) & 1;\
        ifl = (temp16 >> 9) & 1;\
        df = (temp16 >> 10) & 1;\
        of = (temp16 >> 11) & 1;\
}

/*#define modregrm() {\
        addrbyte = getmem8(segregs[regcs], ip); StepIP(1);\
        mode = addrbyte >> 6;\
        reg = (addrbyte >> 3) & 7;\
        rm = addrbyte & 7;\
        switch (mode) {\
                case 0:\
                if (rm == 6) { disp16 = getmem16(segregs[regcs], ip); StepIP(2); }\
                if (((rm == 2) || (rm == 3)) && !segoverride) useseg = segregs[regss]; break;\
                case 1:\
                disp16 = signext(getmem8(segregs[regcs], ip)); StepIP(1);\
                if (((rm == 2) || (rm == 3) || (rm == 6)) && !segoverride) useseg = segregs[regss]; break;\
                case 2:\
                disp16 = getmem16(segregs[regcs], ip); StepIP(2);\
                if (((rm == 2) || (rm == 3) || (rm == 6)) && !segoverride) useseg = segregs[regss]; break;\
                default:\
                disp8 = 0; disp16 = 0;\
        }\
        getea(rm);\
}

#define getea(rmval) {\
        uint32_t tempea;\
        tempea = 0;\
        switch (mode) {\
                case 0:\
                switch (rmval) {\
                        case 0: tempea = regs.wordregs[regbx] + regs.wordregs[regsi]; break;\
                        case 1: tempea = regs.wordregs[regbx] + regs.wordregs[regdi]; break;\
                        case 2: tempea = regs.wordregs[regbp] + regs.wordregs[regsi]; break;\
                        case 3: tempea = regs.wordregs[regbp] + regs.wordregs[regdi]; break;\
                        case 4: tempea = regs.wordregs[regsi]; break;\
                        case 5: tempea = regs.wordregs[regdi]; break;\
                        case 6: tempea = disp16; break;\
                        case 7: tempea = regs.wordregs[regbx]; break;\
                } break;\
                case 1: case 2:\
                switch (rmval) {\
                        case 0: tempea = regs.wordregs[regbx] + regs.wordregs[regsi] + disp16; break;\
                        case 1: tempea = regs.wordregs[regbx] + regs.wordregs[regdi] + disp16; break;\
                        case 2: tempea = regs.wordregs[regbp] + regs.wordregs[regsi] + disp16; break;\
                        case 3: tempea = regs.wordregs[regbp] + regs.wordregs[regdi] + disp16; break;\
                        case 4: tempea = regs.wordregs[regsi] + disp16; break;\
                        case 5: tempea = regs.wordregs[regdi] + disp16; break;\
                        case 6: tempea = regs.wordregs[regbp] + disp16; break;\
                        case 7: tempea = regs.wordregs[regbx] + disp16; break;\
                } break;\
        }\
        ea = (tempea & 0xFFFF) + (useseg << 4);\
}

#define write86(addr32, value) {\
        tempaddr32 = addr32 & 0xFFFFF;\
        if (readonly[tempaddr32]) return;\
        if ((tempaddr32>=0xA0000) && (tempaddr32<=0xBFFFF)) {\
                if ((vidmode!=0x13) && (vidmode!=0x12) && (vidmode!=0xD) && (vidmode!=0x10)) RAM[tempaddr32] = value;\
                else if (((VGA_SC[4] & 6)==0) && (vidmode!=0xD) && (vidmode!=0x10) && (vidmode!=0x12)) RAM[tempaddr32] = value;\
                else writeVGA(tempaddr32-0xA0000, value);\
                updatedscreen = 1;\
        } else {\
                RAM[tempaddr32] = value;\
        }\
}*/

#define genaudio() {\
        if ((curtimer - lastssourcetimer) >= (timerfreq/7000)) {\
           ssourcecursample = getssourcebyte();\
           if (ssourcecursample>0) ssourcecursample -= 128;\
           lastssourcetimer = curtimer;\
        }\
        if ((curtimer - lastspeakertimer) >= (timerfreq/wanted.freq)) {\
           accum = 0;\
           samplestep = (samplestep + 1) % wanted.freq;\
           for (curchan=0; curchan<9; curchan++) {\
                if (adlibfreq(curchan)!=0) {\
                accum += adlibsample(curchan);\
                        if (adlibdidattack[curchan]) adlibenv[curchan] *= adlibdecay[curchan];\
                           else {\
                                adlibenv[curchan] *= adlibattack[curchan];\
                                if (adlibenv[curchan]>=1.0) adlibdidattack[curchan] = 1;\
               }\
                }\
      }\
        accum /= 10;\
        accum += ssourcecursample;\
                if (!speakercountdown) speakercountdown = 1;\
                speakerfreq = 1193180/speakercountdown;\
                if ((portram[0x61]&3)!=0) {\
                        if (curstep<halfstep) accum += 20; else accum -= 20;\
                        curstep++; if (curstep>=fullstep) curstep = 0;\
                }\
        cursample = (accum+128)&255;\
                buf[0][bufpos++] = cursample;\
                if (bufpos==wanted.samples) {\
                        memcpy(&buf[1][0], &buf[0][0], wanted.samples);\
                        bufpos = 0;\
                }\
                lastspeakertimer = curtimer;\
        }\
}

#define timing() {\
   if ((totalexec&TIMERINTERVAL)==0) {\
   curtimer = totalexec;\
        if (doaudio=1) genaudio();\
        if (clocksafe && ((curtimer - lasttimer) >= timerticks)) {\
            doirq(0);\
            didticks++;\
                lasttimer = curtimer;\
        }\
        if ((curtimer - lastcurstimer) >= (timerfreq/3)) {\
                if (cursorvisible) cursorvisible = 0; else cursorvisible = 1;\
                lastcurstimer = curtimer; updatedscreen = 1;\
        }\
   }\
}

#define write86(addr32, value) {\
        tempaddr32 = addr32 & 0xFFFFF;\
        if (readonly[tempaddr32]) return;\
        switch (tempaddr32) {\
                case 0xA0000 ... 0xBFFFF:\
                if ((vidmode!=0x13) && (vidmode!=0x12) && (vidmode!=0xD) && (vidmode!=0x10)) RAM[tempaddr32] = value;\
                else if (((VGA_SC[4] & 6)==0) && (vidmode!=0xD) && (vidmode!=0x10) && (vidmode!=0x12)) RAM[tempaddr32] = value;\
                else writeVGA(tempaddr32-0xA0000, value);\
                updatedscreen = 1;\
                break;\
                default:\
                RAM[tempaddr32] = value;\
        }\
}

#define writew86(addr32, value) {\
        tempaddr32 = addr32 & 0xFFFFF;\
        if (readonly[tempaddr32]) return;\
        switch (tempaddr32) {\
                case 0xA0000 ... 0xBFFFF:\
                if ((vidmode!=0x13) && (vidmode!=0x12) && (vidmode!=0xD) && (vidmode!=0x10)) { RAM[tempaddr32] = value&0xFF; RAM[tempaddr32+1] = value>>8; }\
                else if (((VGA_SC[4] & 6)==0) && (vidmode!=0xD) && (vidmode!=0x10) && (vidmode!=0x12)) { RAM[tempaddr32] = value&0xFF; RAM[tempaddr32+1] = value>>8; }\
                else {\
             tempaddr32 -= 0xA0000;\
             writeVGA(tempaddr32, value&0xFF);\
             writeVGA(tempaddr32+1, value>>8);\
        }\
                updatedscreen = 1;\
                break;\
                default:\
                tempwordptr = (uint16_t *)&RAM[tempaddr32];\
                *tempwordptr = value;\
        }\
}

/*#define flag_szp8(value) {\
   if (!(value)) zf = 1; else zf = 0;\
   if ((value) & 0x80) sf = 1; else sf = 0;\
   pf = parity[value];\
}

#define flag_szp16(value) {\
     if (!value) zf = 1; else zf = 0;\
     if (value & 0x8000) sf = 1; else sf = 0;\
     pf = parity[value & 255];\
}

#define flag_log8(value) {\
     flag_szp8(value);\
     cf = 0; of = 0;\
}

#define flag_log16(value) {\
     flag_szp16(value);\
     cf = 0; of = 0;\
}

#define flag_adc8(v1, v2, v3) {\
        int16_t dst;\
        dst = (int16_t)(v1) + (int16_t)(v2) + (int16_t)(v3);\
        flag_szp8((uint8_t)dst);\
        if (((dst ^ (v1)) & (dst ^ (v2)) & 0x80) == 0x80) of = 1; else of = 0;\
        if (((dst & 0xFF) < ((v1) & 0xFF)) || ((cf & ((((v1) & 0xFF) + ((v2) & 0xFF) + ((v3) & 0xFF)) & 0xFF) == ((v1) & 0xFF))))\
                cf = 1; else cf = 0;\
        if ((((v1) ^ (v2) ^ dst) & 0x10) == 0x10) af = 1; else af = 0;\
}

#define flag_adc16(v1, v2, v3) {\
        dst32 = (int32_t)(v1) + (int32_t)(v2) + (int32_t)(v3);\
        flag_szp16((uint16_t)dst32);\
        if ((((dst32 ^ (v1)) & (dst32 ^ (v2))) & 0x8000) == 0x8000) of = 1; else of = 0;\
        if (((dst32 & 0xFFFF) < ((v1) & 0xFFFF)) || ((cf & ((((v1) & 0xFFFF) + ((v2) & 0xFFFF) + ((v3) & 0xFFFF)) & 0xFFFF) == ((v1) & 0xFFFF))))\
                cf = 1; else cf = 0;\
        if ((((v1) ^ (v2) ^ dst32) & 0x10) == 0x10) af = 1; else af = 0;\
}

#define flag_add8(v1, v2) {\
        dst = (int16_t)(v1) + (int16_t)(v2);\
        flag_szp8((uint8_t)dst);\
        if (dst > 255) cf = 1; else cf = 0;\
        if (((dst ^ (v1)) & (dst ^ (v2)) & 0x80) == 0x80) of = 1; else of = 0;\
        if ((((v1) ^ (v2) ^ dst) & 0x10) == 0x10) af = 1; else af = 0;\
}

#define flag_add16(v1, v2) {\
        dst32 = (int32_t)(v1) + (int32_t)(v2);\
        flag_szp16((uint8_t)dst32);\
        if (dst32 > 65535) cf = 1; else cf = 0;\
        if (((dst32 ^ (v1)) & (dst32 ^ (v2)) & 0x8000) == 0x8000) of = 1; else of = 0;\
        if ((((v1) ^ (v2) ^ dst32) & 0x10) == 0x10) af = 1; else af = 0;\
}

#define flag_sbb8(v1, v2, v3) {\
    (v2) += (v3);\
    dst = (int16_t)(v1) - (int16_t)(v2);\
    flag_szp8(dst & 0xFF);\
    if ((v1) < (v2)) cf = 1; else cf = 0;\
    if ((dst ^ (v1)) & ((v1) ^ (v2)) & 0x80) of = 1; else of = 0;\
    if (((v1) ^ (v2) ^ dst) & 0x10) af = 1; else af = 0;\
}

#define flag_sbb16(v1, v2, v3) {\
    (v2) += (v3);\
    dst32 = (int32_t)(v1) - (int32_t)(v2);\
    flag_szp16(dst32 & 0xFFFF);\
    if ((v1) < (v2)) cf = 1; else cf = 0;\
    if ((dst32 ^ (v1)) & ((v1) ^ (v2)) & 0x8000) of = 1; else of = 0;\
    if (((v1) ^ (v2) ^ dst32) & 0x10) af = 1; else af = 0;\
}

#define flag_sub8(v1, v2) {\
    dst = (int16_t)(v1) - (int16_t)(v2);\
    flag_szp8(dst & 0xFF);\
    if ((v1) < (v2)) cf = 1; else cf = 0;\
    if ((dst ^ (v1)) & ((v1) ^ (v2)) & 0x80) of = 1; else of = 0;\
    if (((v1) ^ (v2) ^ dst) & 0x10) af = 1; else af = 0;\
}

#define flag_sub16(v1, v2) {\
    dst32 = (int32_t)(v1) - (int32_t)(v2);\
    flag_szp16(dst32 & 0xFFFF);\
    if ((v1) < (v2)) cf = 1; else cf = 0;\
    if ((dst32 ^ (v1)) & ((v1) ^ (v2)) & 0x8000) of = 1; else of = 0;\
    if (((v1) ^ (v2) ^ dst32) & 0x10) af = 1; else af = 0;\
}

#define op_adc8() {\
    res8 = oper1b + oper2b + cf;\
    flag_adc8(oper1b, oper2b, cf);\
}

#define op_adc16() {\
    res16 = oper1 + oper2 + cf;\
    flag_adc16(oper1, oper2, cf);\
}

#define op_add8() {\
    res8 = oper1b + oper2b;\
    flag_add8(oper1b, oper2b);\
}

#define op_add16() {\
    res16 = oper1 + oper2;\
    flag_add16(oper1, oper2);\
}

#define op_and8() {\
    res8 = oper1b & oper2b;\
    flag_log8(res8);\
}

#define op_and16() {\
    res16 = oper1 & oper2;\
    flag_log16(res16);\
}

#define op_or8() {\
    res8 = oper1b | oper2b;\
    flag_log8(res8);\
}

#define op_or16() {\
    res16 = oper1 | oper2;\
    flag_log16(res16);\
}

#define op_xor8() {\
    res8 = oper1b ^ oper2b;\
    flag_log8(res8);\
}

#define op_xor16() {\
    res16 = oper1 ^ oper2;\
    flag_log16(res16);\
}

#define op_sub8() {\
    res8 = oper1b - oper2b;\
    flag_sub8(oper1b, oper2b);\
}

#define op_sub16() {\
    res16 = oper1 - oper2;\
    flag_sub16(oper1, oper2);\
}

#define op_sbb8() {\
    res8 = oper1b - (oper2b + cf);\
    flag_sbb8(oper1b, oper2b, cf);\
}

#define op_sbb16() {\
    res16 = oper1 - (oper2 + cf);\
    flag_sbb16(oper1, oper2, cf);\
}
*/
