/* ports.c - handles port I/O for Fake86 CPU core. it's ugly, will fix up later. */

#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>

#ifdef __WATCOMC__
#define inportb(P)      inp(P)
#define inportw(P)      inpw(P)
#define outportb(P,V)   outp(P,V)
#define outportw(P,V)   outpw(P,V)
#endif

uint16_t pit0counter = 65535;
uint32_t speakercountdown, latch42, pit0latch, pit0command, pit0divisor, doclocktick, timerack;
uint16_t portram[256];
extern uint8_t port3da, recvplip, last37a;
FILE *pliplog;

extern uint8_t in8259(uint16_t portnum);
extern void out8259(uint16_t portnum, uint8_t value);

extern uint64_t timerticks, realticks;
extern float timercomp;
void portout(uint16_t portnum, uint16_t value) {
        if (portnum<256) portram[portnum] = value;
        switch (portnum) {
                case 0x20:
                case 0x21: //i8259
                     out8259(portnum, value);
                     return;
                case 0x40: //pit 0 data port
                    switch (pit0command) {
                        case 0xB6:
                        case 0x34:
                        case 0x36:
                        if (pit0latch==0) {
                                pit0divisor = (pit0divisor & 0xFF00) + (value & 0xFF);
                                pit0latch = 1;
                                return;
                        } else {
                                pit0divisor = (pit0divisor & 0xFF) + (value & 0xFF)*256;
                                pit0latch = 0;
                                if (pit0divisor==0) pit0divisor = 65536;
                                return;
                        }
                } break;
                case 0x42: //speaker countdown
                    if (latch42==0) {
                            speakercountdown = (speakercountdown & 0xFF00) + value;
                            latch42 = 1;
                        } else {
                            speakercountdown = (speakercountdown & 0xFF) + value*256;
                            latch42 = 0;
                    } break;
                case 0x43: //pit 0 command port
                    pit0command = value;
                    switch (pit0command) {
                case 0x34:
                case 0x36: //reprogram pit 0 divisor
                    pit0latch = 0; break;
                default:
                    latch42 = 0; break;
                } break;
                
        }
                //if ((portnum>=0x3C0) && (portnum<0x3D9)) {
                //        outportb(portnum, value);
                //}
}

uint16_t portin(uint16_t portnum) {
        switch (portnum) {
                case 0x20:
                case 0x21: //i8259
                    return(in8259(portnum));
                case 0x40:
                    if (pit0latch==0) {
                        pit0latch = 1;
                        return(pit0counter & 0xFF);
                        } else {
                        pit0latch = 0;
                        return((pit0counter >> 8) & 0xFF);
                    }
                case 0x43:
                    return(pit0command);
                case 0x3DA:
                    port3da = (rand() % 2) * 8 + (rand() % 2); //gotta do something about this nastyness
                    return(port3da);
                default:
                    return(0x80);
        }
}

